/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services.amf
{
	import mx.controls.Alert;
	import mx.rpc.AsyncToken;
	import mx.rpc.remoting.RemoteObject;
	
	import org.granite.events.SecurityEvent;
	import org.ow2.sirocco.cloudmanager.model.cimi.extension.User;
	import org.ow2.sirocco.cloudmanager.ui.services.ILoginService;
	import org.ow2.sirocco.cloudmanager.ui.utils.MockServiceUtil;
	
	public class LoginService implements ILoginService
	{
		[Inject(id="userManager")]
		public var service:RemoteObject;
		
		public function login(user:User):AsyncToken
		{
			//service.addEventListener(SecurityEvent.ALL, onSecurityEvent);
			service.setRemoteCredentials(user.username,user.password);
			return service.getUserByUsername(user.username);
		}
		
		private function onSecurityEvent(event:SecurityEvent):void {
			switch (event.type) {
				case SecurityEvent.INVALID_CREDENTIALS:
					Alert.show("Invalid credentials");
					break;
				case SecurityEvent.NOT_LOGGED_IN:
					Alert.show("Not logged in");
					service.logout(); 
					break;
				case SecurityEvent.SESSION_EXPIRED:
					Alert.show("Session expired");
					service.logout(); 
					break;
				case SecurityEvent.ACCESS_DENIED:
					Alert.show("Access denied");
					break;
			}
		}
	}
}