/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services.amf
{
	import mx.rpc.AsyncToken;
	import mx.rpc.remoting.RemoteObject;
	
	import org.granite.collections.BasicMap;
	import org.granite.collections.IMap;
	import org.ow2.sirocco.cloudmanager.model.cimi.system.SystemCreate;
	import org.ow2.sirocco.cloudmanager.model.cimi.system.SystemTemplate;
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.ISystemService;
	
	public class SystemService implements ISystemService
	{
		[Inject(id="systemManager")]
		public var service:RemoteObject;
		
		[Inject]
		public var model:Model;
		
		private var logged:Boolean=false;
		
		
		public function SystemService()
		{
		}
		
		private function login():void {
		//	if(!logged) {
		//		service.setRemoteCredentials(model.loggedInUser.username,model.loggedInUser.password);
		//		logged=true;
		//	}
		}
		
		public function listSystems(first:int, last:int):AsyncToken
		{
			login();
			return service.getSystems(first,last,null,null);
		}
		
		
		public function listSystemTemplates(first:int, last:int):AsyncToken
		{
			login();
			return service.getSystemTemplates(first,last,null,null);
		}
		
		public function startSystem(id:String):AsyncToken
		{
			login();
			return service.startSystem(id);
		}
		
		public function stopSystem(id:String):AsyncToken
		{
			login();
			//XXX
			var force:Boolean=false;
			return service.stopSystem(id);
		}
		
		public function restartSystem(id:String,force:Boolean):AsyncToken
		{
			login();
			return service.restartSystem(id,force);
		}
		
		public function suspendSystem(id:String):AsyncToken
		{
			login();
			return service.suspendSystem(id);
		}
		
		public function deleteSystem(id:String):AsyncToken
		{
			login();
			return service.deleteSystem(id);
		}
		
		public function deleteSystemTemplate(id:String):AsyncToken
		{
			login();
			return service.deleteSystemTemplate(id);
		}
		
		public function createSystem(systemCreate:SystemCreate):AsyncToken
		{
			login();
			return service.createSystem(systemCreate);
		}
		
		public function createSystemTemplate(template:SystemTemplate):AsyncToken
		{
			login();
			return service.createSystemTemplate(template);
		}
	}
}
